#include <QtGui>
#include <QtOpenGL>
#include "sailboat.h"
#include "mainwindow.h"
#include <QGLContext>


sailboat::sailboat()
{   x=0.0; y=0.0; theta =0.0; v = 0.03; omega = 0.0; deltavmax=0.3; phi = 0.5; phiPoint = 0;
    Jx = 3000.0; Jz = 10000.0; // moments d'inertie
    beta=0.3;  rg=4.0;  alphatheta=1500;  m=1000.0;
    alphaf=100.0;  rv=2.0;  alphag=250.0; l=2.0;  alphav=1750.0;
    a=2; psi=1.5*M_PI;  //vent
    eta = 16000;     hv = 4.00;  //Roulis
    dt=0;
}

    sailboat::~sailboat()
    {
    }


    void sailboat::Clock()  // The model is described in "L. Jaulin Modlisation et commande d'un bateau  voile, CIFA2004, Douz (Tunisie)"
    {          gamma=cos(theta-psi)+cos(deltavmax);
               if (gamma<0)  deltav=M_PI-theta+psi; //voile en drapeau
               else  if (sin(theta-psi)>0) deltav=deltavmax;   else deltav=-deltavmax;
               fg = alphag*v*sin(deltag);
               fv = alphav*a*sin(theta+deltav-psi);
               x += (v*cos(theta))*dt;
               y += (v*sin(theta)-beta*a)*dt;
               theta += omega*dt;
               omega += (1/Jz)*((l-rv*cos(deltav))*fv-rg*cos(deltag)*fg-alphatheta*omega)*dt;
               v     += (1/m)*(sin(deltav)*fv-sin(deltag)*fg-alphaf*v)*dt;
               phiPoint += (-phiPoint+fv*hv*cos(deltav)*cos(phi)/Jx - 10000*9.81*sin(phi)/Jx)*dt ;
               phi += phiPoint * dt;
    }

